/* cwho.c :=: 9/25/85   By SLB */

/* 
 * Modified by Lennart Andersson, MOTALA, SWEDEN 
 * 19 october 1987
 */

 
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "defs.h"

struct logs     lbuf;
struct stat	sbuf;

main()          /* Show who's logged into chat */
{
        int     lfile;
        char	tmpstr[40];

        if (stat(LOGFILE, &sbuf) == EOF || sbuf.st_size == 0) {
		puts("No users logged into Chat.");
		exit(0);
	}

	if ((lfile=open(LOGFILE, 0)) == EOF) {
		perror(LOGFILE);
                exit(1);
	}

	sprintf(tmpstr,"%%-%d.%ds %%-%d.%ds  %%%d.%ds\n",NAMELEN,NAMELEN,
	        LINELEN,LINELEN,TIMELEN,TIMELEN);

        puts("Users In Chat         Tty     When");

        while (read(lfile, (char *) &lbuf, sizeof(lbuf))==sizeof(lbuf)) {
                if (lbuf.l_line[0]=='\0' || lbuf.l_name[0]=='\0' ||
			!strncmp(lbuf.l_name, "LOGIN", NAMELEN))
                        continue;       /* Skip blankies */

	        printf(tmpstr, lbuf.l_name, lbuf.l_line, lbuf.l_time);

        }
        if (close(lfile) == EOF) {
                perror(LOGFILE);
                exit(1);
        }
}
